















/*----------------------------------------------------------------------- 
 * 
 * File Name: PROGNAMETest.c
 * 
 * Author: Finn, L. S. 
 * 
 * Revision: $Id: DestroyVectorTest.m4,v 1.2 2000/02/26 21:18:13 jolien Exp $
 * 
 *----------------------------------------------------------------------- 
 * 
 * NAME 
 *   main()
 *
 * SYNOPSIS 
 * 
 * DESCRIPTION 
 *   Test suite for vector factories
 * 
 * DIAGNOSTICS
 * 
 * CALLS
 *   U4CreateVector
 *   U4DestroyVector
 * 
 * NOTES
 *   Automatically generated from dvt.tmpl by m4
 *
 * 
 *-----------------------------------------------------------------------
 */

#ifndef _STDIO_H
#include <stdio.h>
#ifndef _STDIO_H
#define _STDIO_H
#endif
#endif

#ifndef _STRING_H
#include <string.h>
#ifndef _STRING_H
#define _STRING_H
#endif
#endif

#ifndef _LALDATATYPES_H
#include "LALDatatypes.h"
#ifndef _LALDATATYPES_H
#define _LALDATATYPES_H
#endif
#endif

#ifndef _AVFACTORIES_H
#include "AVFactories.h"
#ifndef _AVFACTORIES_H
#define _AVFACTORIES_H
#endif
#endif

NRCSID (MAIN, "$Id: DestroyVectorTest.m4,v 1.2 2000/02/26 21:18:13 jolien Exp $");

int debuglevel = 2;

typedef UINT4Vector vtype;
typedef UINT4 dtype;

int main()
{

  static Status status;		/*  */
  vtype *vector = NULL;		/*  */
  dtype *data = NULL;
  int rcode = 0;

  /* Announcements */
  printf ( "Testing %s\n" , "U4DestroyVector" );

  /* Test error returns */

  /* NULL vector */

  rcode++;	
  U4DestroyVector ( &status, NULL );
  if (status.statusCode != DESTROYVECTOR_EVPTR)   
    printf("FAIL vector == NULL: wrong status code\n");
  else if (strcmp(status.statusDescription,DESTROYVECTOR_MSGEVPTR) != 0)   
    printf("FAIL vector == NULL: statusDescription mismatch\n");
  else 
    {
      rcode--;
      printf("PASS vector == NULL\n");
    }

  /* NULL *vector */

  rcode++;
  U4DestroyVector ( &status, &vector );
  if (status.statusCode != DESTROYVECTOR_EUPTR)   
    printf("FAIL return struct ptr is NULL: wrong status code\n");
  else if (strcmp(status.statusDescription,DESTROYVECTOR_MSGEUPTR) != 0)   
    printf("FAIL return struct ptr is NULL: statusDescription mismatch\n");
  else 
    {
      rcode--;
      printf("PASS return struct ptr is NULL\n");
    }

  /* vector->data == NULL */

  {
    UINT4 length = 10;
    U4CreateVector ( &status, &vector, length );
  }

  rcode++;
  data = vector->data;		/* save pointer to data */
  vector->data = NULL;		/* make mal-formed vector */
  U4DestroyVector ( &status, &vector );
  if (status.statusCode != DESTROYVECTOR_EDPTR)   
    printf("FAIL vector->data == NULL: wrong status code\n");
  else if (strcmp(status.statusDescription,DESTROYVECTOR_MSGEDPTR) != 0)   
    printf("FAIL vector->data == NULL: statusDescription mismatch\n");
  else if (vector == NULL)
    printf("FAIL vector->data == NULL: vector changed\n");
  else 
    { 
      rcode--;
      printf("PASS vector->data == NULL\n");
    }

  /* Test destruction */  

  rcode++;
  vector->data = data;		/* we're correct again */
  U4DestroyVector ( &status, &vector );
  if ( vector != NULL )
    printf("FAIL Destruction: vector != NULL\n");
  else if (status.statusCode != 0)
    printf("FAIL Destruction: normal exit with non-zero statusCode");
  else
    {
      rcode--;
      printf("PASS Destruction\n");
    }

  /* We should have correctly set the status Id field: */

  printf ( "Test results for %s\n", status.Id );
  printf ( "Tested by %s\n", MAIN);

  exit(rcode==0?0:-1);
}
